<?php
/**
 * A class for handling currency data and formatting.
 *
 * Copyright 2020 Red Delta Group LLC
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software and
 * associated documentation files (the "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies or substantial
 * portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT
 * LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *
 * @author     Jeff Ussing <Jeff.Ussing@RedDeltaGroup.com>
 * @copyright  2020 Red Delta Group LLC
 * @link       http://RedDeltaGroup.com
 * @link       https://GitLab.com/RedDeltaGroup/Public
 */


/**
 * Class Currency
 */
class Currency
{
   /**
    * @var array[]
    */
   private $currency_data = [
      // Select ISO 4217 Currencies
         'ALL'  => ['name'            => 'Albania Lek',
                    'character'       => 'Lek',
                    'html_entity'     => '&#76;&#101;&#107;',
                    'hex'             => '&#x4C;&#x65;&#x6B;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'AFN'  => ['name'            => 'Afghanistan Afghani',
                    'character'       => 'Af',
                    'html_entity'     => '&#65;&#102;',
                    'hex'             => '&#x41;&#x66;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'ARS'  => ['name'            => 'Argentina Peso',
                    'character'       => '$',
                    'html_entity'     => '&#36;',
                    'hex'             => '&#x24;',
                    'symbol_position' => 'left',
                    'nbsp'            => true,
                    'decimals'        => 2,
                    'dec_point'       => ',',
                    'thousands_sep'   => '.',
         ],
         'AWG'  => ['name'            => 'Aruba Guilder',
                    'character'       => 'ƒ',
                    'html_entity'     => '&#402;',
                    'hex'             => '&#x192;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'AUD'  => ['name'            => 'Australia Dollar',
                    'character'       => 'A$',
                    'html_entity'     => '&#65;&#36;',
                    'hex'             => '&#x41;&#x24;',
                    'symbol_position' => 'left',
                    'nbsp'            => true,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'AZN'  => ['name'            => 'Azerbaijan New Manat',
                    'character'       => 'ман',
                    'html_entity'     => '&#1084;&#1072;&#1085;',
                    'hex'             => '&#x43C;&#x430;&#x43D;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'BSD'  => ['name'            => 'Bahamas Dollar',
                    'character'       => 'B$',
                    'html_entity'     => '&#66;&#36;',
                    'hex'             => '&#x42;&#x24;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'BBD'  => ['name'            => 'Barbados Dollar',
                    'character'       => '$',
                    'html_entity'     => '&#36;',
                    'hex'             => '&#x24;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'BDT'  => ['name'            => 'Bangladeshi taka',
                    'character'       => '৳',
                    'html_entity'     => '&#2547;',
                    'hex'             => '&#x9F3;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'BYR'  => ['name'            => 'Belarus Ruble',
                    'character'       => 'p.',
                    'html_entity'     => '&#112;&#46;',
                    'hex'             => '&#x70;&#x2E;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'BZD'  => ['name'            => 'Belize Dollar',
                    'character'       => 'BZ$',
                    'html_entity'     => '&#66;&#90;&#36;',
                    'hex'             => '&#x42;&#x5A;&#x24;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'BMD'  => ['name'            => 'Bermuda Dollar',
                    'character'       => '$',
                    'html_entity'     => '&#36;',
                    'hex'             => '&#x24;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'BOB'  => ['name'            => 'Bolivia Boliviano',
                    'character'       => '$b',
                    'html_entity'     => '&#36;&#98;',
                    'hex'             => '&#x24;&#x62;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'BAM'  => ['name'            => 'Bosnia and Herzegovina Convertible Marka',
                    'character'       => 'KM',
                    'html_entity'     => '&#75;&#77;',
                    'hex'             => '&#x4B;&#x4D;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'BWP'  => ['name'            => 'Botswana Pula',
                    'character'       => 'P',
                    'html_entity'     => '&#80;',
                    'hex'             => '&#x50;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'BGN'  => ['name'            => 'Bulgaria Lev',
                    'character'       => 'лв',
                    'html_entity'     => '&#1083;&#1074;',
                    'hex'             => '&#x43B;&#x432;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'BRL'  => ['name'            => 'Brazil Real',
                    'character'       => 'R$',
                    'html_entity'     => '&#82;&#36;',
                    'hex'             => '&#x52;&#x24;',
                    'symbol_position' => 'left',
                    'nbsp'            => true,
                    'decimals'        => 2,
                    'dec_point'       => ',',
                    'thousands_sep'   => '.',
         ],
         'BND'  => ['name'            => 'Brunei Darussalam Dollar',
                    'character'       => '$',
                    'html_entity'     => '&#36;',
                    'hex'             => '&#x24;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'KHR'  => ['name'            => 'Cambodia Riel',
                    'character'       => '៛',
                    'html_entity'     => '&#6107;',
                    'hex'             => '&#x17DB;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'CAD'  => ['name'            => 'Canada Dollar',
                    'character'       => '$',
                    'html_entity'     => '&#36;',
                    'hex'             => '&#x24;',
                    'symbol_position' => 'left',
                    'nbsp'            => true,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'KYD'  => ['name'            => 'Cayman Islands Dollar',
                    'character'       => '$',
                    'html_entity'     => '&#36;',
                    'hex'             => '&#x24;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'CLP'  => ['name'            => 'Chile Peso',
                    'character'       => '$',
                    'html_entity'     => '&#36;',
                    'hex'             => '&#x24;',
                    'symbol_position' => 'left',
                    'nbsp'            => true,
                    'decimals'        => 0,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'CNY'  => ['name'            => 'China Yuan Renminbi',
                    'character'       => '¥',
                    'html_entity'     => '&#165;',
                    'hex'             => '&#xA5;',
                    'symbol_position' => 'left',
                    'nbsp'            => true,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'COP'  => ['name'            => 'Colombia Peso',
                    'character'       => '$',
                    'html_entity'     => '&#36;',
                    'hex'             => '&#x24;',
                    'symbol_position' => 'left',
                    'nbsp'            => true,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'CRC'  => ['name'            => 'Costa Rica Colon',
                    'character'       => '₡',
                    'html_entity'     => '&#8353;',
                    'hex'             => '&#x20A1;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'HRK'  => ['name'            => 'Croatia Kuna',
                    'character'       => 'kn',
                    'html_entity'     => '&#107;&#110;',
                    'hex'             => '&#x6b;&#x6e;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'CUP'  => ['name'            => 'Cuba Peso',
                    'character'       => '₱',
                    'html_entity'     => '&#8369;',
                    'hex'             => '&#x20B1;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'CZK'  => ['name'            => 'Czech Republic Koruna',
                    'character'       => 'Kč',
                    'html_entity'     => '&#75;&#269;',
                    'hex'             => '&#x4b;&#x10d;',
                    'symbol_position' => 'right',
                    'nbsp'            => true,
                    'decimals'        => 2,
                    'dec_point'       => ',',
                    'thousands_sep'   => '.',
         ],
         'DKK'  => ['name'            => 'Denmark Krone',
                    'character'       => 'kr.',
                    'html_entity'     => '&#107;&#114;&#46;',
                    'hex'             => '&#x6b;&#x72;&#x2E;',
                    'symbol_position' => 'left',
                    'nbsp'            => true,
                    'decimals'        => 2,
                    'dec_point'       => ',',
                    'thousands_sep'   => '.',
         ],
         'DOP'  => ['name'            => 'Dominican Republic Peso',
                    'character'       => 'RD$',
                    'html_entity'     => '&#82;&#68;&#36;',
                    'hex'             => '&#x52;&#x44;&#x24;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'XCD'  => ['name'            => 'East Caribbean Dollar',
                    'character'       => '$',
                    'html_entity'     => '&#36;',
                    'hex'             => '&#x24;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'EGP'  => ['name'            => 'Egypt Pound',
                    'character'       => '£',
                    'html_entity'     => '&#163;',
                    'hex'             => '&#xA3;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'SVC'  => ['name'            => 'El Salvador Colon',
                    'character'       => '$',
                    'html_entity'     => '&#36;',
                    'hex'             => '&#x24;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'EEK'  => ['name'            => 'Estonia Kroon',
                    'character'       => 'kr',
                    'html_entity'     => '&#107;&#114;',
                    'hex'             => '&#x6b;&#x72;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'EUR'  => ['name'            => 'Euro Member Countries',
                    'character'       => '€',
                    'html_entity'     => '&#8364;',
                    'hex'             => '&#x20ac;',
                    'symbol_position' => 'left',
                    'nbsp'            => true,
                    'decimals'        => 2,
                    'dec_point'       => ',',
                    'thousands_sep'   => '.',
         ],
         'FKP'  => ['name'            => 'Falkland Islands (Malvinas) Pound',
                    'character'       => '£',
                    'html_entity'     => '&#163;',
                    'hex'             => '&#xA3;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'FJD'  => ['name'            => 'Fiji Dollar',
                    'character'       => 'FJ$',
                    'html_entity'     => '&#70;&#74;&#36;',
                    'hex'             => '&#x46;&#x4a;&#x24;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'GHC'  => ['name'            => 'Ghana Cedis',
                    'character'       => 'GH₵',
                    'html_entity'     => '&#71;&#72;&#8373;',
                    'hex'             => '&#x47;&#x48;&#x20B5;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'GIP'  => ['name'            => 'Gibraltar Pound',
                    'character'       => '£',
                    'html_entity'     => '&#163;',
                    'hex'             => '&#xA3;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'GTQ'  => ['name'            => 'Guatemala Quetzal',
                    'character'       => 'Q',
                    'html_entity'     => '&#81;',
                    'hex'             => '&#x51;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'GGP'  => ['name'            => 'Guernsey Pound',
                    'character'       => '£',
                    'html_entity'     => '&pound;',
                    'hex'             => '&#xA3;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'GYD'  => ['name'            => 'Guyana Dollar',
                    'character'       => '$',
                    'html_entity'     => '&#36;',
                    'hex'             => '&#x24;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'HNL'  => ['name'            => 'Honduras Lempira',
                    'character'       => 'L',
                    'html_entity'     => '&#76;',
                    'hex'             => '&#x4c;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'HKD'  => ['name'            => 'Hong Kong Dollar',
                    'character'       => '$',
                    'html_entity'     => '&#36;',
                    'hex'             => '&#x24;',
                    'symbol_position' => 'left',
                    'nbsp'            => true,
                    'decimals'        => 2,
                    'dec_point'       => ',',
                    'thousands_sep'   => '.',
         ],
         'HUF'  => ['name'            => 'Hungary Forint',
                    'character'       => 'Ft',
                    'html_entity'     => '&#70;&#116;',
                    'hex'             => '&#x46;&#x74;',
                    'symbol_position' => 'right',
                    'nbsp'            => true,
                    'decimals'        => 2,
                    'dec_point'       => ',',
                    'thousands_sep'   => '.',
         ],
         'ISK'  => ['name'            => 'Iceland Krona',
                    'character'       => 'kr',
                    'html_entity'     => '&#107;&#114;',
                    'hex'             => '&#x6b;&#x72;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 0,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'INR'  => ['name'            => 'India Rupee',
                    'character'       => '₹',
                    'html_entity'     => '&#8377;',
                    'hex'             => '&#x20b9;',
                    'symbol_position' => 'left',
                    'nbsp'            => true,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'IDR'  => ['name'            => 'Indonesia Rupiah',
                    'character'       => 'Rp',
                    'html_entity'     => '&#82;&#112;',
                    'hex'             => '&#x52;&#x70;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'IRR'  => ['name'            => 'Iran Rial',
                    'character'       => '﷼',
                    'html_entity'     => '&#65020;',
                    'hex'             => '&#xFDFC;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'IMP'  => ['name'            => 'Isle of Man Pound',
                    'character'       => '£',
                    'html_entity'     => '&pound;',
                    'hex'             => '&#xA3;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'ILS'  => ['name'            => 'Israel Shekel',
                    'character'       => '₪',
                    'html_entity'     => '&#8362;',
                    'hex'             => '&#x20aa;',
                    'symbol_position' => 'left',
                    'nbsp'            => true,
                    'decimals'        => 2,
                    'dec_point'       => ',',
                    'thousands_sep'   => '.',
         ],
         'JMD'  => ['name'            => 'Jamaica Dollar',
                    'character'       => 'J$',
                    'html_entity'     => '&#74;&#36;',
                    'hex'             => '&#x4a;&#x24;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'JPY'  => ['name'            => 'Japan Yen',
                    'character'       => '¥',
                    'html_entity'     => '&#165;',
                    'hex'             => '&#xa5;',
                    'symbol_position' => 'left',
                    'nbsp'            => true,
                    'decimals'        => 0,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'JEP'  => ['name'            => 'Jersey Pound',
                    'character'       => '£',
                    'html_entity'     => '&pound;',
                    'hex'             => '&#xA3;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'KZT'  => ['name'            => 'Kazakhstan Tenge',
                    'character'       => 'лв',
                    'html_entity'     => '&#1083;&#1074;',
                    'hex'             => '&#x43B;&#x432;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'KPW'  => ['name'            => 'Korea (North) Won',
                    'character'       => '₩',
                    'html_entity'     => '&#8361;',
                    'hex'             => '&#x20a9;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'KRW'  => ['name'            => 'Korea (South) Won',
                    'character'       => '₩',
                    'html_entity'     => '&#8361;',
                    'hex'             => '&#x20a9;',
                    'symbol_position' => 'left',
                    'nbsp'            => true,
                    'decimals'        => 0,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'KGS'  => ['name'            => 'Kyrgyzstan Som',
                    'character'       => 'лв',
                    'html_entity'     => '&#1083;&#1074;',
                    'hex'             => '&#x43B;&#x432;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'LAK'  => ['name'            => 'Laos Kip',
                    'character'       => '₭',
                    'html_entity'     => '&#8365;',
                    'hex'             => '&#x20AD;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'LVL'  => ['name'            => 'Latvia Lat',
                    'character'       => 'Ls',
                    'html_entity'     => '&#76;&#115;',
                    'hex'             => '&#x4C;&#x73;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'LBP'  => ['name'            => 'Lebanon Pound',
                    'character'       => '£',
                    'html_entity'     => '&pound;',
                    'hex'             => '&#xA3;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'LRD'  => ['name'            => 'Liberia Dollar',
                    'character'       => '$',
                    'html_entity'     => '&#36;',
                    'hex'             => '&#x24;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'LTL'  => ['name'            => 'Lithuania Litas',
                    'character'       => 'Lt',
                    'html_entity'     => '&#76;&#116;',
                    'hex'             => '&#x4C;&#x74;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'MAD'  => ['name'            => 'Moroccan Dirham',
                    'character'       => '.د.م',
                    'html_entity'     => '&#46;&#1583;&#46;&#1605;',
                    'hex'             => '&#x2e;&#x62f;&#x2e;&#x645;',
                    'symbol_position' => 'right',
                    'nbsp'            => true,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'MKD'  => ['name'            => 'Macedonia Denar',
                    'character'       => 'ден',
                    'html_entity'     => '&#1076;&#1077;&#1085;',
                    'hex'             => '&#x434;&#x435;&#x43D;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'MYR'  => ['name'            => 'Malaysia Ringgit',
                    'character'       => 'RM',
                    'html_entity'     => '&#82;&#77;',
                    'hex'             => '&#x52;&#x4d;',
                    'symbol_position' => 'left',
                    'nbsp'            => true,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'MUR'  => ['name'            => 'Mauritius Rupee',
                    'character'       => '₨',
                    'html_entity'     => '&#8360;',
                    'hex'             => '&#x20A8;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'MXN'  => ['name'            => 'Mexico Peso',
                    'character'       => '$',
                    'html_entity'     => '&#36;',
                    'hex'             => '&#x24;',
                    'symbol_position' => 'left',
                    'nbsp'            => true,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'MNT'  => ['name'            => 'Mongolia Tughrik',
                    'character'       => '₮',
                    'html_entity'     => '&#8366;',
                    'hex'             => '&#x20AE;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'MZN'  => ['name'            => 'Mozambique Metical',
                    'character'       => 'MT',
                    'html_entity'     => '&#77;&#84;',
                    'hex'             => '&#x4D;&#x54;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'NAD'  => ['name'            => 'Namibia Dollar',
                    'character'       => '$',
                    'html_entity'     => '&#36;',
                    'hex'             => '&#x24;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'NPR'  => ['name'            => 'Nepal Rupee',
                    'character'       => '₨',
                    'html_entity'     => '&#8360;',
                    'hex'             => '&#x20A8;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'ANG'  => ['name'            => 'Netherlands Antilles Guilder',
                    'character'       => 'ƒ',
                    'html_entity'     => '&#402;',
                    'hex'             => '&#x192;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'NZD'  => ['name'            => 'New Zealand Dollar',
                    'character'       => '$',
                    'html_entity'     => '&#36;',
                    'hex'             => '&#x24;',
                    'symbol_position' => 'left',
                    'nbsp'            => true,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'NIO'  => ['name'            => 'Nicaragua Cordoba',
                    'character'       => 'C$',
                    'html_entity'     => '&#67;&#36;',
                    'hex'             => '&#x43;&#x24;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'NGN'  => ['name'            => 'Nigeria Naira',
                    'character'       => '₦',
                    'html_entity'     => '&#8358;',
                    'hex'             => '&#x20A6;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'NOK'  => ['name'            => 'Norway Krone',
                    'character'       => 'kr',
                    'html_entity'     => '&#107;&#114;',
                    'hex'             => '&#x6b;&#x72;',
                    'symbol_position' => 'left',
                    'nbsp'            => true,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'OMR'  => ['name'            => 'Oman Rial',
                    'character'       => '﷼',
                    'html_entity'     => '&#65020;',
                    'hex'             => '&#xFDFC;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 3,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'PKR'  => ['name'            => 'Pakistan Rupee',
                    'character'       => '₨',
                    'html_entity'     => '&#8360;',
                    'hex'             => '&#x20A8;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'PAB'  => ['name'            => 'Panama Balboa',
                    'character'       => 'B/.',
                    'html_entity'     => '&#66;&#47;&#46;',
                    'hex'             => '&#x42;&#x2f;&#x2e;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'PYG'  => ['name'            => 'Paraguay Guarani',
                    'character'       => 'Gs',
                    'html_entity'     => '&#71;&#115;',
                    'hex'             => '&#x47;&#x73;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 0,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'PEN'  => ['name'            => 'Peru Nuevo Sol',
                    'character'       => 'S/.',
                    'html_entity'     => '&#83;&#47;&#46;',
                    'hex'             => '&#x53;&#x2f;&#x2e;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'PHP'  => ['name'            => 'Philippines Peso',
                    'character'       => '₱',
                    'html_entity'     => '&#8369;',
                    'hex'             => '&#x20b1;',
                    'symbol_position' => 'left',
                    'nbsp'            => true,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'PLN'  => ['name'            => 'Poland Zloty',
                    'character'       => 'zł',
                    'html_entity'     => '&#122;&#322;',
                    'hex'             => '&#x7a;&#x142;',
                    'symbol_position' => 'right',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => ',',
                    'thousands_sep'   => '.',
         ],
         'QAR'  => ['name'            => 'Qatar Riyal',
                    'character'       => '﷼',
                    'html_entity'     => '&#65020;',
                    'hex'             => '&#xFDFC;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'RON'  => ['name'            => 'Romania New Leu',
                    'character'       => 'lei',
                    'html_entity'     => '&#108;&#101;&#105;',
                    'hex'             => '&#x6c;&#x65;&#x69;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'RUB'  => ['name'            => 'Russia Ruble',
                    'character'       => 'руб',
                    'html_entity'     => '&#1088;&#1091;&#1073;',
                    'hex'             => '&#x440;&#x443;&#x431;',
                    'symbol_position' => 'right',
                    'nbsp'            => true,
                    'decimals'        => 2,
                    'dec_point'       => ',',
                    'thousands_sep'   => '.',
         ],
         'SHP'  => ['name'            => 'Saint Helena Pound',
                    'character'       => '£',
                    'html_entity'     => '&pound;',
                    'hex'             => '&#xA3;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'SAR'  => ['name'            => 'Saudi Arabia Riyal',
                    'character'       => '﷼',
                    'html_entity'     => '&#65020;',
                    'hex'             => '&#xFDFC;',
                    'symbol_position' => 'right',
                    'nbsp'            => true,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'RSD'  => ['name'            => 'Serbia Dinar',
                    'character'       => 'Дин.',
                    'html_entity'     => '&#1044;&#1080;&#1085;&#46;',
                    'hex'             => '&#x414;&#x438;&#x43D;&#x2E;&#xA;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'SCR'  => ['name'            => 'Seychelles Rupee',
                    'character'       => '₨',
                    'html_entity'     => '&#8360;',
                    'hex'             => '&#x20A8;&#xA;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'SGD'  => ['name'            => 'Singapore Dollar',
                    'character'       => 'S$',
                    'html_entity'     => '&#83;&#36;',
                    'hex'             => '&#x53;&#x24;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'SBD'  => ['name'            => 'Solomon Islands Dollar',
                    'character'       => '$',
                    'html_entity'     => '&#36;',
                    'hex'             => '&#x24;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'SOS'  => ['name'            => 'Somalia Shilling',
                    'character'       => 'S',
                    'html_entity'     => '&#83;',
                    'hex'             => '&#x53;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'ZAR'  => ['name'            => 'South Africa Rand',
                    'character'       => 'R',
                    'html_entity'     => '&#82;',
                    'hex'             => '&#x52;',
                    'symbol_position' => 'left',
                    'nbsp'            => true,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'LKR'  => ['name'            => 'Sri Lanka Rupee',
                    'character'       => '₨',
                    'html_entity'     => '&#8360;',
                    'hex'             => '&#x20A8;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'SEK'  => ['name'            => 'Sweden Krona',
                    'character'       => 'kr',
                    'html_entity'     => '&#107;&#114;',
                    'hex'             => '&#x6b;&#x72;',
                    'symbol_position' => 'right',
                    'nbsp'            => true,
                    'decimals'        => 2,
                    'dec_point'       => ',',
                    'thousands_sep'   => '.',
         ],
         'CHF'  => ['name'            => 'Switzerland Franc',
                    'character'       => 'CHF',
                    'html_entity'     => '&#67;&#72;&#70;',
                    'hex'             => '&#x43;&#x48;&#x46;',
                    'symbol_position' => 'left',
                    'nbsp'            => true,
                    'decimals'        => 2,
                    'dec_point'       => ',',
                    'thousands_sep'   => '.',
         ],
         'SRD'  => ['name'            => 'Suriname Dollar',
                    'character'       => '$',
                    'html_entity'     => '&#36;',
                    'hex'             => '&#x24;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'SYP'  => ['name'            => 'Syria Pound',
                    'character'       => '£',
                    'html_entity'     => '&pound;',
                    'hex'             => '&#xA3;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'TWD'  => ['name'            => 'Taiwan New Dollar',
                    'character'       => 'NT$',
                    'html_entity'     => '&#78;&#84;&#36;',
                    'hex'             => '&#x4e;&#x54;&#x24;',
                    'symbol_position' => 'left',
                    'nbsp'            => true,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'THB'  => ['name'            => 'Thailand Baht',
                    'character'       => '฿',
                    'html_entity'     => '&#3647;',
                    'hex'             => '&#xe3f;',
                    'symbol_position' => 'right',
                    'nbsp'            => true,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'TTD'  => ['name'            => 'Trinidad and Tobago Dollar',
                    'character'       => '$',
                    'html_entity'     => '&#36;',
                    'hex'             => '&#x24;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'TRY'  => ['name'            => 'Turkey Lira (New)',
                    'character'       => '₤',
                    'html_entity'     => '&#8356;',
                    'hex'             => '&#x20A4;',
                    'symbol_position' => 'right',
                    'nbsp'            => true,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'TRL'  => ['name'            => 'Turkey Lira (Old)',
                    'character'       => '₤',
                    'html_entity'     => '&#8356;',
                    'hex'             => '&#x20A4;',
                    'symbol_position' => 'right',
                    'nbsp'            => true,
                    'decimals'        => '0',
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'TVD'  => ['name'            => 'Tuvalu Dollar',
                    'character'       => '$',
                    'html_entity'     => '&#36;',
                    'hex'             => '&#x24;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'UAH'  => ['name'            => 'Ukraine Hryvna',
                    'character'       => '₴',
                    'html_entity'     => '&#8372;',
                    'hex'             => '&#x20B4;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'GBP'  => ['name'            => 'UK/Great Britain Pound Sterling',
                    'character'       => '£',
                    'html_entity'     => '&#163;',
                    'hex'             => '&#xA3;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'USD'  => ['name'            => 'United States Dollar',
                    'character'       => '$',
                    'html_entity'     => '&#36;',
                    'hex'             => '&#x24;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'UYU'  => ['name'            => 'Uruguay Peso',
                    'character'       => '$U',
                    'html_entity'     => '&#36;&#85;',
                    'hex'             => '&#x24;&#x55;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'UZS'  => ['name'            => 'Uzbekistan Som',
                    'character'       => 'лв',
                    'html_entity'     => '&#1083;&#1074;',
                    'hex'             => '&#x43B;&#x432;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'VEF'  => ['name'            => 'Venezuela Bolivar',
                    'character'       => 'Bs',
                    'html_entity'     => '&#66;&#115;',
                    'hex'             => '&#x42;&#x73;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'VND'  => ['name'            => 'Vietnam Dong',
                    'character'       => '₫',
                    'html_entity'     => '&#8363;',
                    'hex'             => '&#x20ab;',
                    'symbol_position' => 'right',
                    'nbsp'            => true,
                    'decimals'        => 0,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'YER'  => ['name'            => 'Yemen Rial',
                    'character'       => '﷼',
                    'html_entity'     => '&#65020;',
                    'hex'             => '&#xFDFC;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'ZWD'  => ['name'            => 'Zimbabwe Dollar',
                    'character'       => '$',
                    'html_entity'     => '&#36;',
                    'hex'             => '&#x24;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 2,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
      // Cryptocurrencies
         'XBT'  => ['name'            => 'Bitcoin',
                    'character'       => '₿',
                    'html_entity'     => '&#8383;',
                    'hex'             => '&#x20bf;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 8,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'BCH'  => ['name'            => 'Bitcoin Cash',
                    'character'       => '₿',
                    'html_entity'     => '&#8383;',
                    'hex'             => '&#x20bf;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 8,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'LTC'  => ['name'            => 'Litecoin',
                    'character'       => 'Ł',
                    'html_entity'     => '&Lstrok;',
                    'hex'             => '&#x0141;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 8,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'XRP'  => ['name'            => 'Ripple',
                    'character'       => '₡',
                    'html_entity'     => '&#8353;',
                    'hex'             => '&#x20A1;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 6,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'LBR'  => ['name'            => 'Libra Coins',
                    'character'       => '≋',
                    'html_entity'     => '&apid;',
                    'hex'             => '&#x224B;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 8,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'USDT' => ['name'            => 'Tether',
                    'character'       => '₮',
                    'html_entity'     => '&#8366;',
                    'hex'             => '&#x20AE;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 8,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
         'TRX'  => ['name'            => 'TRON (Tronix)',
                    'character'       => '₡',
                    'html_entity'     => '&#8353;',
                    'hex'             => '&#x20A1;',
                    'symbol_position' => 'left',
                    'nbsp'            => false,
                    'decimals'        => 8,
                    'dec_point'       => '.',
                    'thousands_sep'   => ',',
         ],
   ];

   /**
    * @param $currency_code
    *
    * @return string
    */
   public function get_name($currency_code)
   {
      if (!empty($this->currency_data[$currency_code]['name']))
         return (string)$this->currency_data[$currency_code]['name'];
      else
         return 'Currency Sign';
   }

   /**
    * @param $currency_code
    *
    * @return string
    */
   public function get_character($currency_code)
   {
      if (!empty($this->currency_data[$currency_code]['character']))
         return (string)$this->currency_data[$currency_code]['character'];
      else
         return '¤';
   }

   /**
    * @param $currency_code
    *
    * @return string
    */
   public function get_html_entity($currency_code)
   {
      if (!empty($this->currency_data[$currency_code]['html_entity']))
         return (string)$this->currency_data[$currency_code]['html_entity'];
      else
         return '&curren;';
   }

   /**
    * @param $currency_code
    *
    * @return string
    */
   public function get_hex($currency_code)
   {
      if (!empty($this->currency_data[$currency_code]['hex']))
         return (string)$this->currency_data[$currency_code]['hex'];
      else
         return '&#xA4;';
   }

   /**
    * @param $currency_code
    *
    * @return string
    */
   public function get_symbol_position($currency_code)
   {
      if (!empty($this->currency_data[$currency_code]['symbol_position']))
         return (string)$this->currency_data[$currency_code]['symbol_position'];
      else
         return 'left';
   }

   /**
    * @param $currency_code
    *
    * @return bool
    */
   public function get_nbsp($currency_code)
   {
      if (!empty($this->currency_data[$currency_code]['nbsp']))
         return (string)$this->currency_data[$currency_code]['nbsp'];
      else
         return true;
   }

   /**
    * @param $currency_code
    *
    * @return int
    */
   public function get_decimals($currency_code)
   {
      if (!empty($this->currency_data[$currency_code]['decimals']))
         return (int)$this->currency_data[$currency_code]['decimals'];
      else
         return 2;
   }

   /**
    * @param $currency_code
    *
    * @return string
    */
   public function get_dec_point($currency_code)
   {
      if (!empty($this->currency_data[$currency_code]['dec_point']))
         return (string)$this->currency_data[$currency_code]['dec_point'];
      else
         return '.';
   }

   /**
    * @param $currency_code
    *
    * @return string
    */
   public function get_thousands_sep($currency_code)
   {
      if (!empty($this->currency_data[$currency_code]['thousands_sep']))
         return (string)$this->currency_data[$currency_code]['thousands_sep'];
      else
         return ',';
   }


   /**
    * @param        $number
    * @param string $currency_code
    *
    * @return string
    */
   public function format_number_currency($number, $currency_code = 'USD')
   {
      if (!array_key_exists($currency_code, $this->currency_data))
         return (string)$number;

      $html_entity = $this->get_html_entity($currency_code);
      $nbsp = $this->get_nbsp($currency_code);
      $decimals = $this->get_decimals($currency_code);
      $dec_point = $this->get_dec_point($currency_code);
      $thousands_sep = $this->get_thousands_sep($currency_code);
      if ($this->get_symbol_position($currency_code) == 'left')
         return $html_entity . $nbsp . number_format($number, $decimals, $dec_point, $thousands_sep);
      else
         return number_format($number, $decimals, $dec_point, $thousands_sep) . $nbsp . $html_entity;
   }
}
